﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;

namespace OpenAIClient
{
    internal class OpenAI
    {
        public static string CallOpenAISync(string apiKey, string model, string prompt)
        {
            var request = (HttpWebRequest)WebRequest.Create("http://localhost:1234/v1/chat/completions");
            request.Method = "POST";
            request.Headers["Authorization"] = "Bearer " + apiKey;
            request.ContentType = "application/json";

            // 1️⃣ 封装 JSON 请求对象
            var message = new Dictionary<string, string>
        {
            { "role", "user" },
            { "content", prompt }
        };

            var requestBody = new
            {
                model = model,
                messages = new[] { message }
            };

            string jsonData = JsonConvert.SerializeObject(requestBody);

            // 2️⃣ 写入请求体
            using (var streamWriter = new StreamWriter(request.GetRequestStream()))
            {
                streamWriter.Write(jsonData);
            }

            try
            {
                // 3️⃣ 获取响应
                var response = (HttpWebResponse)request.GetResponse();
                using (var streamReader = new StreamReader(response.GetResponseStream()))
                {
                    string result = streamReader.ReadToEnd();

                    // 4️⃣ 解析 JSON 响应，提取文本
                    JObject jsonResponse = JObject.Parse(result);

                    string content = jsonResponse["choices"]?[0]?["message"]?["content"]?.ToString();
                    return content ?? "(未找到回答内容)";
                }
            }
            catch (WebException ex)
            {
                using (var stream = ex.Response.GetResponseStream())
                using (var reader = new StreamReader(stream))
                {
                    string error = reader.ReadToEnd();
                    Console.WriteLine("错误: " + error);
                }
                return "(请求失败)";
            }
        }
    }
}
